#!/bin/sh

set -e
set -u

RUN_OID=".1.3.6.1.4.1.9.9.43.1.1.1.0"
START_OID=".1.3.6.1.4.1.9.9.43.1.1.3.0"
SNMP_ARGS="-Otv -v2c -c"
host=""
community=""

set -- $(/usr/bin/getopt -u -l hostname: -l community: H:C: $*)
while [ $# -gt 0 ]; do
   case "$1" in
      "-H"|"--hostname")
          host=$2
          shift
          shift
      ;;
      "-C"|"--community")
          community=$2
          shift
          shift
      ;;
      *)
          shift
      ;;
   esac
done

if [ "$community" = "" -o "$host" = "" ]; then
   echo "Usage: check_cisco_config.sh -H <ip_address> -C <community>"
   exit 3
fi

if [ -x /usr/bin/snmpget ]; then
   startup=$(/usr/bin/snmpget $SNMP_ARGS $community $host $START_OID)
   running=$(/usr/bin/snmpget $SNMP_ARGS $community $host $RUN_OID)
   if [ "$startup" -gt "$running" ]; then
      echo "Running config has safely been written to flash."
      exit 0
   else
      if [ "$startup" -lt "$running" ]; then
         echo "Running config is newer than startup config. write mem."
         exit 2
      fi
   fi
fi

echo "There is a disturbance in the force."
exit 3
