#!/bin/sh

set -u
set -e

lockdir=/var/lock
fname=staging.lock

if [ -f ${lockdir}/${fname} ]; then
   if [ $(find $lockdir -name $fname -type f -mmin +1800) ]; then
      echo "CRIT: ${lockdir}/${fname} is more than 30 hours old."
      exit 2
   elif [ $(find $lockdir -name $fname -type f -mmin +1440) ]; then
      echo "WARN: ${lockdir}/${fname} is more than 24 hours old."
      exit 1
   else
      echo "OK: ${lockdir}/${fname} is less than 24 hours old."
      exit 0
   fi
else
   echo "OK: ${lockdir}/${fname} does not exist."
   exit 0
fi
echo "ERR: Unknown state."
exit 3
